package demo;

import org.eclipse.swt.widgets.*;
import org.eclipse.draw2d.*;
import org.eclipse.draw2d.Button;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.*;

public class Flowchart {
	public static void main(String args[]) {
		Shell shell = new Shell();
		shell.setSize(300, 400);
		shell.open();
		shell.setText("Flowchart");
		LightweightSystem lws = new LightweightSystem(shell);
		ChartFigure flowchart = new ChartFigure();
		lws.setEventDispatcher(new SWTEventDispatcherX(1800000L));		
		lws.setContents(flowchart);
		TerminatorFigure start = new TerminatorFigure();
		start.setName("Start");
		start.setToolTip(new Label(""));
		start.setBounds(new Rectangle(40, 20, 80, 20));
		DecisionFigure dec = new DecisionFigure();
		dec.setName("Should I?");
		dec.setBounds(new Rectangle(30, 60, 100, 60));
		ProcessFigure proc = new ProcessFigure();
		proc.setName("Do it!");
		proc.setToolTip(new Button("do it"));		
		proc.setBounds(new Rectangle(40, 140, 80, 40));
		TerminatorFigure stop = new TerminatorFigure();
		stop.setName("End");
		stop.setBounds(new Rectangle(140, 300, 80, 20));
		PathFigure path1 = new PathFigure();
		path1.setSourceAnchor(start.outAnchor);
		path1.setTargetAnchor(dec.inAnchor);
		PathFigure path2 = new PathFigure();
		path2.setSourceAnchor(dec.yesAnchor);
		path2.setTargetAnchor(proc.inAnchor);
		PathFigure path3 = new PathFigure();
		path3.setSourceAnchor(dec.noAnchor);
		path3.setTargetAnchor(stop.inAnchor);
		PathFigure path4 = new PathFigure();
		path4.setSourceAnchor(proc.outAnchor);
		path4.setTargetAnchor(stop.inAnchor);
		flowchart.add(start);
		flowchart.add(dec);
		flowchart.add(proc);
		flowchart.add(stop);
		flowchart.add(path1);
		flowchart.add(path2);
		flowchart.add(path3);
		flowchart.add(path4);
		new Dnd(start);
		new Dnd(proc);
		new Dnd(dec);
		new Dnd(stop);
		Display display = Display.getDefault();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}
}
